// Copyright Erkki Seppl 2002
// $Id$
// $Author$ 
// $Revision$

static char* gs_id __attribute__ ((unused)) ="$Id$"; /// ID for CVS/RCS

#include "parallelloop.hh"

#include <iostream>

#include <cstdio>
#include <string.h>

#include <assert.h>
#include <unistd.h>
#include <sys/wait.h>

int ParallelLoop::defaultNumCPUs = 2;

ParallelLoop::ParallelLoop(int a_begin, int a_threads) :
  m_threads(a_threads ? a_threads : defaultNumCPUs)
{
  m_increment = m_threads.size();
  m_isMaster = false;
  for (int c = 0; c < m_threads.size(); ++c) {
    if (c == 0) {
      m_counter = c + a_begin;
      m_threads[c] = 0;
    } else {
      m_threads[c] = fork();
      if (m_threads[c] == 0) {
        m_counter = c + a_begin;
        return;
      }
    }
  }
  m_isMaster = true;
}

bool
ParallelLoop::operator<(int a_boundary)
{
  return m_counter < a_boundary;
}

int
ParallelLoop::operator++()
{
  return m_counter += m_increment;
}

ParallelLoop::operator int()
{
  return m_counter;
}

ParallelLoop::~ParallelLoop()
{
  if (m_isMaster) {
    for (int c = 1; c < m_threads.size(); ++c) {
      assert(waitpid(m_threads[c], 0, 0) != -1);
    }
  } else {
    std::cerr.~ostream();
    std::cout.~ostream();
    _exit(0);
  }
}


// changelog:
//
// $Log$
