// Copyright Erkki Seppl 2002
// $Id$
// $Author$ 
// $Revision$

static char* gs_id __attribute__ ((unused)) ="$Id$"; /// ID for CVS/RCS

#include "sharedmemory.hh"

#include <assert.h>
#include <unistd.h>
#include <sys/mman.h>
#include <fcntl.h>

SharedMemory::SharedMemory(int a_bytes) :
  m_bytes(a_bytes)
{
  int fd = open("/dev/zero", O_RDWR);
  assert(fd >= 0);
  m_block = mmap(0, a_bytes, PROT_READ | PROT_WRITE,
                 MAP_PRIVATE, fd, 0);
  assert(reinterpret_cast<int>(m_block) != -1);
}

SharedMemory::~SharedMemory()
{
  munmap(m_block, m_bytes);
}

int
SharedMemory::size() const
{
  return m_bytes;
}

void*
SharedMemory::get()
{
  return m_block;
}

const void*
SharedMemory::get() const
{
  return m_block;
}


// changelog:
//
// $Log$
